package com.usercentrics.sdk.flutter.mock

import com.usercentrics.sdk.flutter.api.FakeFlutterMethodCall
import com.usercentrics.sdk.v2.location.data.UsercentricsLocation
import com.usercentrics.sdk.v2.settings.data.*

internal object GetCMPDataMock {

    val fakeCategories = listOf(
        UsercentricsCategory(
            categorySlug = "essential",
            description = "These technologies are required to activate the core functionality of the website.",
            isEssential = true,
            label = "Essential",
        )
    )
    val fakeUserLocation = UsercentricsLocation(
        countryCode = "PT",
        regionCode = "PTLX"
    )
    val fakeServices = listOf(
        UsercentricsService(
            templateId = "ABC",
            version = "1.2.3",
            type = "predefined",
            dataProcessor = "Google Ads",
            dataPurposes = listOf("Advertising Conversion Tracking"),
            processingCompany = "Google Ireland Limited, Google Building Gordon House",
            nameOfProcessingCompany = "Google Ireland Limited",
            addressOfProcessingCompany = "Google Building Gordon House",
            descriptionOfService = "This is a conversion tracking service. ",
            languagesAvailable = listOf("en"),
            dataCollectedList = listOf("IP adress"),
            dataPurposesList = listOf("Analytics"),
            dataRecipientsList = listOf("Google Ireland Limited"),
            legalBasisList = listOf("Art. 6 para. 1 s. 1 lit. a GDPR"),
            retentionPeriodList = listOf(),
            subConsents = listOf(),
            language = "en",
            linkToDpa = "",
            legalGround = "Art. 6 para. 1 s. 1 lit. c GDPR",
            optOutUrl = "",
            policyOfProcessorUrl = "https://usercentrics.com/de/datenschutzerklarung/",
            categorySlug = "essential",
            retentionPeriodDescription = "The consent data (given consent and revocation of consent) are stored for three years. The data will then be deleted immediately or given to the person responsible on request in the form of a data export.",
            dataProtectionOfficer = "datenschutz@usercentrics.com",
            privacyPolicyURL = "https://usercentrics.com/privacy-policy/",
            cookiePolicyURL = "",
            locationOfProcessing = "European Union",
            dataCollectedDescription = "",
            thirdCountryTransfer = "Worldwide",
            description = "",
            cookieMaxAgeSeconds = null,
            usesNonCookieAccess = null,
            deviceStorageDisclosureUrl = null,
            isDeactivated = false,
            disableLegalBasis = false,
            technologyUsed = listOf("Cookies", "Pixel Tags")
        )
    )
    private val fakeLabels = UsercentricsLabels(
        dataPurposes = "Data Purposes",
        accepted = "yes",
        denied = "no",
        history = "History",
        settings = "Settings",
        subConsents = "Subservices",
        btnAccept = "Accept",
        btnDeny = "Deny",
        secondLayerTitle = "Privacy Settings Title",
        secondLayerDescriptionHtml = "Privacy Settings Description",
        btnMore = "more",
        poweredBy = "Powered by <a href=\"https://usercentrics.com/?utm_source=cmp&utm_medium=powered_by\" rel=\"nofollow\" target=\"_blank\">Usercentrics Consent Management</a>",
        technologiesUsed = "Technologies Used",
        dataCollectedList = "Data Collected",
        processingCompanyTitle = "Processing Company",
        legalBasisList = "Legal Basis",
        retentionPeriod = "Retention Period",
        locationOfProcessing = "Location of Processing",
        transferToThirdCountries = "Transfer to Third Countries",
        furtherInformationOptOut = "Further Information and Opt-Out",
        dataProtectionOfficer = "Data Protection Officer of Processing Company",
        nameOfProcessingCompany = "Processing Company",
        addressOfProcessingCompany = "Address of processing company",
        optOut = "Click here to opt out from this processor across all domains",
        policyOf = "Click here to read the privacy policy of the data processor",
        dataCollectedInfo = "This list represents all (personal) data that is collected by or through the use of this service.",
        legalBasisInfo = "In the following the required legal basis for the processing of data is listed.",
        dataRecipientsList = "Data Recipients",
        transferToThirdCountriesInfo = "This service may forward the collected data to a different country. Please note that this service might transfer the data outside of the EU/EEA and to a country without the required data protection standards. If the data is transferred to the US, there is a risk that your data can be processed by US authorities, for control and surveillance measures, possibly without legal remedies. Below you can find a list of countries to which the data is being transferred. This can be for different reasons like storing or processing.",
        linkToDpaInfo = "Data Processing Agreement",
        dataPurposesInfo = "This list represents the purposes of the data collection and processing.",
        technologiesUsedInfo = "This list represents all technologies this service uses to collect data. Typical technologies are Cookies and Pixels that are placed in the browser.",
        btnBannerReadMore = "Read more",
        descriptionOfService = "Description of Service",
        technology = "Technology being used to process the data",
        notAvailable = "not available",
        date = "Date",
        minute = "minute",
        minutes = "minutes",
        hour = "hour",
        hours = "hours",
        day = "day",
        days = "days",
        month = "month",
        months = "months",
        year = "year",
        years = "years",
        consent = "Consent",
        categories = "Categories",
        language = "Language",
        btnSave = "Save Services",
        btnMoreInfo = "More Info",
        btnBack = "Back",
        copy = "copy",
        copied = "copied",
        view = "view",
        more = "more",
        less = "less",
        consents = "Consents",
        headerModal = "This tool helps you to select and deactivate various tags / trackers / analytic tools used on this website.",
        basic = "Basic",
        advanced = "Advanced",
        processingCompany = "Processing Company",
        cookiePolicyInfo = "Click here to read the cookie policy of the data processor",
        imprintLinkText = "Imprint",
        privacyPolicyLinkText = "Privacy Policy",
        cookiePolicyLinkText = "Cookie Policy",
        btnAcceptAll = "Accept All",
        firstLayerTitle = "Privacy Settings",
        historyDescription = "",
        consentType = "Consent type",
        decision = "Decision",
        explicit = "Explicit",
        implicit = "Implicit",
        storageInformation = "Storage Information",
        maximumAgeCookieStorage = "Maximum age of cookie storage",
        second = "second",
        seconds = "seconds",
        nonCookieStorage = "Non-cookie storage",
        detailedStorageInformation = "Detailed Storage Information",
        loadingStorageInformation = "Loading storage information",
        name = "Name",
        identifier = "Identifier",
        duration = "Duration",
        type = "Type",
        domain = "Domain",
        informationLoadingNotPossible = "Sorry, we could not load the required information.",
        yes = "yes",
        session = "Session",
        no = "no",
        tryAgain = "Try again?",
        anyDomain = "any domain (ex. first party cookie)",
        multipleDomains = "multiple subdomains may exist",
        storageInformationDescription = "Below you can see the longest potential duration for storage on a device, as set when using the cookie method of storage and if there are any other methods used.",
    )
    private val fakeFirstLayer = FirstLayer(
        hideButtonDeny = false,
    )
    private val fakeSecondLayer = SecondLayer(
        tabsServicesLabel = "Services",
        hideLanguageSwitch = false,
        tabsCategoriesLabel = "Categories",
        hideButtonDeny = false,
        hideTogglesForServices = false,
        acceptButtonText = "Accept All",
        denyButtonText = "Deny All",
    )
    private val fakeTCF2Settings = TCF2Settings(
        togglesSpecialFeaturesToggleOff = "Off",
        secondLayerTitle = "Privacy Settings Title",
        tabsVendorsLabel = "Vendors",
        labelsIabVendors = "Vendors who are part of the IAB TCF",
        buttonsDenyAllLabel = "Deny all",
        resurfacePeriodEnded = true,
        vendorSpecialPurposes = "Special Purposes",
        firstLayerAdditionalInfo = "",
        resurfaceVendorAdded = true,
        disabledSpecialFeatures = listOf(),
        resurfacePurposeChanged = true,
        firstLayerHideButtonDeny = false,
        hideLegitimateInterestToggles = false,
        secondLayerHideButtonDeny = false,
        secondLayerHideToggles = false,
        togglesConsentToggleLabel = "Consent",
        labelsFeatures = "Features",
        togglesSpecialFeaturesToggleOn = "On",
        vendorSpecialFeatures = "Special Features",
        appLayerNoteResurface =
        "You can change your privacy settings or withdraw your consent at any time by opening the menu point Privacy Settings.",
        cmpVersion = 3,
        firstLayerDescription =
        "We and our third-party vendors use technologies (e.g. cookies) to store and/or access information on user's devices in order to process personal data such as IP addresses or browsing data. You may consent to the processing of your personal data for the listed purposes below. Alternatively you can set your preferences before consenting or refuse to consent. Please note that some vendors may process your personal data based on their legitimate business interest and do not ask for your consent. To exercise your right to object to processing based on legitimate interest please view our vendorlist.",
        firstLayerShowDescriptions = false,
        labelsPurposes = "Purposes",
        firstLayerNoteResurface =
        "You can change your privacy settings or withdraw your consent at any time by clicking on our Privacy Button.",
        firstLayerTitle = "Privacy Information",
        vendorLegitimateInterestPurposes = "Purposes processed by Legitimate Interest",
        selectedStacks = listOf(),
        labelsNonIabPurposes = "Non-IAB Purposes",
        togglesLegIntToggleLabel = "Legitimate Interest",
        vendorPurpose = "Purposes processed by Consent",
        labelsNonIabVendors = "Vendors who are not part of the IAB TCF",
        purposeOneTreatment = false,
        cmpId = 5,
        vendorFeatures = "Features",
        secondLayerDescription =
        "You can access more detailed information below regarding all purposes and third-party vendors implemented on this website. You can adjust your privacy settings based on specific purposes and/or at a vendor level at any time.",
        publisherCountryCode = "DE",
        buttonsSaveLabel = "Save Settings",
        selectedVendorIds = listOf(),
        buttonsAcceptAllLabel = "Accept all",
        hideNonIabOnFirstLayer = false,
        linksManageSettingsLabel = "Manage Settings",
        firstLayerHideToggles = false,
        gdprApplies = true,
        linksVendorListLinkLabel = "Vendorlist",
        tabsPurposeLabel = "Purposes"
    )
    private val fakeCCPASettings = CCPASettings(
        secondLayerHideLanguageSwitch = false,
        secondLayerTitle = "Privacy Settings Title",
        iabAgreementExists = false,
        optOutNoticeLabel = "Do not sell my personal information",
        btnSave = "OK",
        showOnPageLoad = false,
        btnMoreInfo = "More Information",
        firstLayerTitle = "Privacy Information",
        appFirstLayerDescription =
        "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please refer to our privacy policy.",
        isActive = false,
        secondLayerDescription =
        "Here you can find detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information.",
        firstLayerMobileDescriptionIsActive = false,
        reshowAfterDays = 365,
        firstLayerMobileDescription =
        "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below.",
    )
    private val fakeCustomization = UsercentricsCustomization(
        color = CustomizationColor(
            primary = "0045A5"
        ),
        font = CustomizationFont(
            family =
            "BlinkMacSystemFont,-apple-system,Segoe UI,Roboto,Oxygen-Sans,Ubuntu,Cantarell,Fira Sans,Droid Sans,Helvetica Neue,Helvetica,Arial,sans-serif",
            size = 14
        ),
        logoUrl = "https://www.munich-startup.de/wp-content/uploads/2018/01/usercentrics-logo-4c@4x.png"
    )
    val fakeSettings = UsercentricsSettings(
        labels = fakeLabels,
        showInitialViewForVersionChange = listOf(),
        reshowBanner = null,
        displayOnlyForEU = false,
        secondLayer = fakeSecondLayer,
        cookiePolicyUrl = "",
        tcf2 = fakeTCF2Settings,
        ccpa = fakeCCPASettings,
        privacyPolicyUrl = "https://usercentrics.com/privacy-policy/",
        firstLayer = fakeFirstLayer,
        imprintUrl = "https://usercentrics.com/legal-notice/",
        firstLayerDescriptionHtml = "Privacy Settings test description.",
        bannerMobileDescriptionIsActive = false,
        firstLayerMobileDescriptionHtml = "",
        version = "6.0.4",
        language = "en",
        tcf2Enabled = false,
        settingsId = "lQ_Dio7QL",
        languagesAvailable = listOf("en", "de"),
        enablePoweredBy = true,
        editableLanguages = listOf("en", "de"),
        customization = fakeCustomization,
    )

    // From the debugger
    val call = FakeFlutterMethodCall(method = "getCMPData", arguments = null)
    private val expectedFirstLayer = mapOf(
        "hideButtonDeny" to false,
    )
    private val expectedSecondLayer = mapOf(
        "tabsCategoriesLabel" to "Categories",
        "tabsServicesLabel" to "Services",
        "hideButtonDeny" to false,
        "hideLanguageSwitch" to false,
        "acceptButtonText" to "Accept All",
        "denyButtonText" to "Deny All",
    )
    private val expectedLabels = mapOf(
        "btnAcceptAll" to "Accept All",
        "btnDeny" to "Deny",
        "btnSave" to "Save Services",
        "firstLayerTitle" to "Privacy Settings",
        "accepted" to "yes",
        "denied" to "no",
        "date" to "Date",
        "decision" to "Decision",
        "dataCollectedList" to "Data Collected",
        "dataCollectedInfo" to "This list represents all (personal) data that is collected by or through the use of this service.",
        "locationOfProcessing" to "Location of Processing",
        "transferToThirdCountries" to "Transfer to Third Countries",
        "dataPurposes" to "Data Purposes",
        "dataPurposesInfo" to "This list represents the purposes of the data collection and processing.",
        "dataRecipientsList" to "Data Recipients",
        "descriptionOfService" to "Description of Service",
        "history" to "History",
        "historyDescription" to "",
        "legalBasisList" to "Legal Basis",
        "legalBasisInfo" to "In the following the required legal basis for the processing of data is listed.",
        "processingCompanyTitle" to "Processing Company",
        "technologiesUsed" to "Technologies Used",
        "technologiesUsedInfo" to "This list represents all technologies this service uses to collect data. Typical technologies are Cookies and Pixels that are placed in the browser.",
        "cookiePolicyInfo" to "Click here to read the cookie policy of the data processor",
        "optOut" to "Click here to opt out from this processor across all domains",
        "policyOf" to "Click here to read the privacy policy of the data processor",
        "imprintLinkText" to "Imprint",
        "privacyPolicyLinkText" to "Privacy Policy",
        "categories" to "Categories",
        "anyDomain" to "any domain (ex. first party cookie)",
        "day" to "day",
        "days" to "days",
        "domain" to "Domain",
        "duration" to "Duration",
        "informationLoadingNotPossible" to "Sorry, we could not load the required information.",
        "hour" to "hour",
        "hours" to "hours",
        "identifier" to "Identifier",
        "maximumAgeCookieStorage" to "Maximum age of cookie storage",
        "minute" to "minute",
        "minutes" to "minutes",
        "month" to "month",
        "months" to "months",
        "multipleDomains" to "multiple subdomains may exist",
        "no" to "no",
        "nonCookieStorage" to "Non-cookie storage",
        "seconds" to "seconds",
        "session" to "Session",
        "loadingStorageInformation" to "Loading storage information",
        "storageInformation" to "Storage Information",
        "detailedStorageInformation" to "Detailed Storage Information",
        "tryAgain" to "Try again?",
        "type" to "Type",
        "year" to "year",
        "years" to "years",
        "yes" to "yes",
        "storageInformationDescription" to "Below you can see the longest potential duration for storage on a device, as set when using the cookie method of storage and if there are any other methods used.",
        "btnBannerReadMore" to "Read more",
        "linkToDpaInfo" to "Data Processing Agreement",
        "second" to "second",
        "consent" to "Consent",
        "secondLayerTitle" to "Privacy Settings Title",
        "secondLayerDescriptionHtml" to "Privacy Settings Description",
        "btnMore" to "more",
        "retentionPeriod" to "Retention Period",
        "explicit" to "Explicit"
    )
    private val expectedTCF2Settings = mapOf(
        "firstLayerTitle" to "Privacy Information",
        "secondLayerTitle" to "Privacy Settings Title",
        "tabsPurposeLabel" to "Purposes",
        "tabsVendorsLabel" to "Vendors",
        "labelsFeatures" to "Features",
        "labelsIabVendors" to "Vendors who are part of the IAB TCF",
        "labelsNonIabPurposes" to "Non-IAB Purposes",
        "labelsNonIabVendors" to "Vendors who are not part of the IAB TCF",
        "labelsPurposes" to "Purposes",
        "vendorFeatures" to "Features",
        "vendorLegitimateInterestPurposes" to "Purposes processed by Legitimate Interest",
        "vendorPurpose" to "Purposes processed by Consent",
        "vendorSpecialFeatures" to "Special Features",
        "vendorSpecialPurposes" to "Special Purposes",
        "togglesConsentToggleLabel" to "Consent",
        "togglesLegIntToggleLabel" to "Legitimate Interest",
        "buttonsAcceptAllLabel" to "Accept all",
        "buttonsDenyAllLabel" to "Deny all",
        "buttonsSaveLabel" to "Save Settings",
        "linksManageSettingsLabel" to "Manage Settings",
        "linksVendorListLinkLabel" to "Vendorlist",
        "cmpId" to 5,
        "cmpVersion" to 3,
        "firstLayerHideToggles" to false,
        "secondLayerHideToggles" to false,
        "hideLegitimateInterestToggles" to false,
        "firstLayerHideButtonDeny" to false,
        "secondLayerHideButtonDeny" to false,
        "publisherCountryCode" to "DE",
        "purposeOneTreatment" to false,
        "selectedVendorIds" to listOf<Any>(),
        "gdprApplies" to true,
        "selectedStacks" to listOf<Any>(),
        "disabledSpecialFeatures" to listOf<Any>(),
        "firstLayerShowDescriptions" to false,
        "hideNonIabOnFirstLayer" to false,
        "resurfacePeriodEnded" to true,
        "resurfacePurposeChanged" to true,
        "resurfaceVendorAdded" to true,
        "firstLayerDescription" to "We and our third-party vendors use technologies (e.g. cookies) to store and/or access information on user's devices in order to process personal data such as IP addresses or browsing data. You may consent to the processing of your personal data for the listed purposes below. Alternatively you can set your preferences before consenting or refuse to consent. Please note that some vendors may process your personal data based on their legitimate business interest and do not ask for your consent. To exercise your right to object to processing based on legitimate interest please view our vendorlist.",
        "firstLayerAdditionalInfo" to "",
        "secondLayerDescription" to "You can access more detailed information below regarding all purposes and third-party vendors implemented on this website. You can adjust your privacy settings based on specific purposes and/or at a vendor level at any time.",
        "togglesSpecialFeaturesToggleOn" to "On",
        "togglesSpecialFeaturesToggleOff" to "Off",
        "appLayerNoteResurface" to "You can change your privacy settings or withdraw your consent at any time by opening the menu point Privacy Settings.",
        "firstLayerNoteResurface" to "You can change your privacy settings or withdraw your consent at any time by clicking on our Privacy Button.",
    )
    private val expectedCCPASettings = mapOf(
        "optOutNoticeLabel" to "Do not sell my personal information",
        "btnSave" to "OK",
        "firstLayerTitle" to "Privacy Information",
        "isActive" to false,
        "showOnPageLoad" to false,
        "reshowAfterDays" to 365,
        "iabAgreementExists" to false,
        "appFirstLayerDescription" to "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below. For detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information please refer to our privacy policy.",
        "firstLayerMobileDescriptionIsActive" to false,
        "firstLayerMobileDescription" to "We and our partners are using technologies like cookies and process personal data in order to improve your experience. In case of sale of your personal information you may exercise your consumer right to opt-out by activating the toggle 'Do Not Sell My Personal Information' below.",
        "secondLayerTitle" to "Privacy Settings Title",
        "secondLayerDescription" to "Here you can find detailed information about the categories of personal information we collect and the purposes for which information may be used and which Data Processing Services may have access to this information.",
        "secondLayerHideLanguageSwitch" to false,
        "btnMoreInfo" to "More Information",
    )
    private val expectedCustomization = mapOf(
        "color" to mapOf(
            "primary" to "0045A5",
            "acceptBtnText" to null,
            "acceptBtnBackground" to null,
            "denyBtnText" to null,
            "denyBtnBackground" to null,
            "saveBtnText" to null,
            "saveBtnBackground" to null,
            "linkIcon" to null,
            "linkFont" to null,
            "text" to null,
            "layerBackground" to null,
            "overlay" to null,
            "toggleInactiveBackground" to null,
            "toggleInactiveIcon" to null,
            "toggleActiveBackground" to null,
            "toggleActiveIcon" to null,
            "toggleDisabledBackground" to null,
            "toggleDisabledIcon" to null,
            "secondLayerTab" to null,
            "moreBtnBackground" to null,
            "moreBtnText" to null,
        ),
        "font" to mapOf(
            "family" to "BlinkMacSystemFont,-apple-system,Segoe UI,Roboto,Oxygen-Sans,Ubuntu,Cantarell,Fira Sans,Droid Sans,Helvetica Neue,Helvetica,Arial,sans-serif",
            "size" to 14
        ),
        "logoUrl" to "https://www.munich-startup.de/wp-content/uploads/2018/01/usercentrics-logo-4c@4x.png",
        "borderRadiusLayer" to null,
        "borderRadiusButton" to null,
        "overlayOpacity" to null,
    )
    val expectedSettings = mapOf(
        "labels" to expectedLabels,
        "showInitialViewForVersionChange" to listOf<Any>(),
        "reshowBanner" to null,
        "displayOnlyForEU" to false,
        "secondLayer" to expectedSecondLayer,
        "cookiePolicyUrl" to "",
        "tcf2" to expectedTCF2Settings,
        "ccpa" to expectedCCPASettings,
        "privacyPolicyUrl" to "https://usercentrics.com/privacy-policy/",
        "firstLayer" to expectedFirstLayer,
        "imprintUrl" to "https://usercentrics.com/legal-notice/",
        "firstLayerDescriptionHtml" to "Privacy Settings test description.",
        "bannerMobileDescriptionIsActive" to false,
        "firstLayerMobileDescriptionHtml" to "",
        "version" to "6.0.4",
        "language" to "en",
        "tcf2Enabled" to false,
        "settingsId" to "lQ_Dio7QL",
        "languagesAvailable" to listOf("en", "de"),
        "enablePoweredBy" to true,
        "editableLanguages" to listOf("en", "de"),
        "customization" to expectedCustomization,
    )
    val expectedCategories = listOf(
        mapOf(
            "categorySlug" to "essential",
            "label" to "Essential",
            "description" to "These technologies are required to activate the core functionality of the website.",
            "isEssential" to true,
        )
    )
    val expectedUserLocation = mapOf(
        "countryCode" to "PT",
        "regionCode" to "PTLX",
        "isInEU" to true,
        "isInUS" to false,
        "isInCalifornia" to false,
    )
    val expectedServices = listOf(
        mapOf(
            "templateId" to "ABC",
            "version" to "1.2.3",
            "type" to "predefined",
            "dataProcessor" to "Google Ads",
            "dataPurposes" to listOf("Advertising Conversion Tracking"),
            "processingCompany" to "Google Ireland Limited, Google Building Gordon House",
            "nameOfProcessingCompany" to "Google Ireland Limited",
            "addressOfProcessingCompany" to "Google Building Gordon House",
            "descriptionOfService" to "This is a conversion tracking service. ",
            "languagesAvailable" to listOf("en"),
            "dataCollectedList" to listOf("IP adress"),
            "dataPurposesList" to listOf("Analytics"),
            "dataRecipientsList" to listOf("Google Ireland Limited"),
            "legalBasisList" to listOf("Art. 6 para. 1 s. 1 lit. a GDPR"),
            "retentionPeriodList" to listOf<String>(),
            "subConsents" to listOf<String>(),
            "language" to "en",
            "linkToDpa" to "",
            "legalGround" to "Art. 6 para. 1 s. 1 lit. c GDPR",
            "optOutUrl" to "",
            "policyOfProcessorUrl" to "https://usercentrics.com/de/datenschutzerklarung/",
            "categorySlug" to "essential",
            "retentionPeriodDescription" to "The consent data (given consent and revocation of consent) are stored for three years. The data will then be deleted immediately or given to the person responsible on request in the form of a data export.",
            "dataProtectionOfficer" to "datenschutz@usercentrics.com",
            "privacyPolicyURL" to "https://usercentrics.com/privacy-policy/",
            "cookiePolicyURL" to "",
            "locationOfProcessing" to "European Union",
            "dataCollectedDescription" to "",
            "thirdCountryTransfer" to "Worldwide",
            "description" to "",
            "cookieMaxAgeSeconds" to null,
            "usesNonCookieAccess" to null,
            "deviceStorageDisclosureUrl" to null,
            "isDeactivated" to false,
            "disableLegalBasis" to false,
            "isEssential" to false,
            "technologyUsed" to listOf("Cookies", "Pixel Tags")
        )
    )

}
